#include <stdio.h>
#include <math.h> 
#include <stdlib.h> 
#include <string.h>

int i;
int eye,r,g,b,percent;
int rr,gg,bb;

int grid[5];
int black[3];

char plan[2],cube[3];
int orig;

char vertex[126][200];
int num[9],p[9][4];

float kr,kg,kb,k[4];
float K1,K2,cont,shift;

float P1[4],P2[4],P3[4],P4[4],P5[4],P6[4],out[4],out2[4];

FILE *dolby,*table1,*table2,*rgb,*yuv;
unsigned char Rout,Gout,Bout;
long int addr;
float *buffer;
int y,u,v;
char path[200],name[200],fullname[200];

/****************************************************************************/

main()
{
	dolby=fopen("trilinear.ini","r");
		for(i=1;i<=4;++i)fgets(vertex[i],200,dolby);	/* get parameters */
	fclose(dolby);
	sscanf(vertex[1],"%s",&path);
	sscanf(vertex[2],"%s",&name);
	sscanf(vertex[3],"%d %d",&black[1],&black[2]);
	sscanf(vertex[4],"%f %f %f %f",&K1,&K2,&cont,&shift);

	if(black[1]>black[2]){black[1]=black[1]-black[2]; black[2]=0; }
	else                 {black[2]=black[2]-black[1]; black[1]=0; }

/********************************************************************************/
/*
                                                  (401)
                                                   301     5x5 CUBE
                                                   201
                         CUBE                      101
                      R---------M                  001--002--003--004--005
                      |\        |\                   \ 00 \    \    \    \
                      | \       | \                  006--007--008--009--010
                      |  \      |  \                   \    \ 11 \    \    \
                      |   Y---------White              011--012--013--014--015
                  blacK---|-----B   |                    \    \    \ 22 \    \
                       \  |      \  |                    016--017--018--019--020
                        \ |       \ |                      \    \    \    \ 33 \
                         \|        \|                      021--022--023--024--025
                          G---------C  
*/

sprintf(fullname,"%s\\%s",path,name);

dolby=fopen(fullname,"r"); if(dolby==NULL){printf("%s : File does not exist\n",fullname);exit(0);}
	fgets(vertex[1],100,dolby);
	sscanf(vertex[1],"%d %d %d",&grid[1],&grid[2],&grid[3]); grid[0]=0; grid[4]=255;

addr=3*256*256*256;
buffer=(float*)malloc(addr*4);
if (buffer == NULL) {fputs ("Memory error",stderr); exit (2);}

for(eye=1;eye<=2;++eye){
	for(i=1;i<=125;++i)fgets(vertex[i],100,dolby);

	addr=0;

		printf("\n");
		if(eye==1)printf("Computing trilinear interpolation  TABLE 1\n\n");
		if(eye==2)printf("Computing trilinear interpolation  TABLE 2\n\n");
		printf("0      10      20      30      40      50     60     70     80     90    100%%\n");

percent=0;
for(g=0;g<256;++g){
	if(percent!=g*78/256)printf(".");
	percent=g*78/256;
for(b=0;b<256;++b){
for(r=0;r<256;++r){
/******************************************************ascertain sub-cube********/

if(r>=grid[0]&&r<grid[1])rr=0;		/* n de grid */
if(r>=grid[1]&&r<grid[2])rr=1;
if(r>=grid[2]&&r<grid[3])rr=2;
if(r>=grid[3]&&r<=grid[4])rr=3;

if(g>=grid[0]&&g<grid[1])gg=0;
if(g>=grid[1]&&g<grid[2])gg=1;
if(g>=grid[2]&&g<grid[3])gg=2;
if(g>=grid[3]&&g<=grid[4])gg=3;

if(b>=grid[0]&&b<grid[1])bb=0;
if(b>=grid[1]&&b<grid[2])bb=1;
if(b>=grid[2]&&b<grid[3])bb=2;
if(b>=grid[3]&&b<=grid[4])bb=3;

sprintf(cube,"%d%d",gg,bb);		/* numro cube au sol */
sprintf(plan,"%d",rr);			/* plan */

kr=(float)(r-grid[rr]) / (float)( grid[rr+1]-grid[rr] );	/* real deltas in %   must be < 1 */
kg=(float)(g-grid[gg]) / (float)( grid[gg+1]-grid[gg] );
kb=(float)(b-grid[bb]) / (float)( grid[bb+1]-grid[bb] );

/******************************************************floor origin number*******/
if(atoi(cube)>= 0&&atoi(cube)<10)orig=atoi(cube)+1;
if(atoi(cube)>=10&&atoi(cube)<20)orig=atoi(cube)-4;
if(atoi(cube)>=20&&atoi(cube)<30)orig=atoi(cube)-9;
if(atoi(cube)>=30&&atoi(cube)<40)orig=atoi(cube)-14;
/******************************************************line number in file******/
num[1]=orig+atoi(plan)*25;			/* which floor ? */

		  num[2]=num[1]+1;   num[3]=num[1]+5;   num[4]=num[1]+6;  /* name the other 3 vertices */
num[5]=num[1]+25; num[6]=num[1]+26;  num[7]=num[1]+30;  num[8]=num[1]+31; /* 4 vertices next floor */

/* num[] is in fact line number in input file */

/******************************************************corrected 8 vertex cube**/
for(i=1;i<=8;++i)sscanf(vertex[num[i]],"%d %d %d",&p[i][1],&p[i][2],&p[i][3]);

/******************************************************trilinear interpolation**/
		for(i=1;i<=3;++i){
			P1[i]=p[1][i]+kr*(p[5][i]-p[1][i]);
			P2[i]=p[2][i]+kr*(p[6][i]-p[2][i]);
			P3[i]=p[3][i]+kr*(p[7][i]-p[3][i]);
			P4[i]=p[4][i]+kr*(p[8][i]-p[4][i]);

			P5[i]=P1[i]+kb*(P2[i]-P1[i]);
			P6[i]=P3[i]+kb*(P4[i]-P3[i]);

			out[i]=P5[i]+kg*(P6[i]-P5[i]);
		}
/******************************************************black levels*************/
		for(i=1;i<=3;++i)out[i]=out[i]*(255-black[eye])/255 + black[eye];

/******************************************************Scurve*******************/
if(K2>0){ for(i=1;i<=3;++i)out[i]=(float)(K1+atan(cont*(out[i]/127-1+shift)))*K2;}

/******************************************************SAVE*********************/
for(i=1;i<=3;++i){ if(out[i]>255)out[i]=255; if(out[i]<0)out[i]=0; }	/* R G B */

buffer[addr]=out[1]; ++addr;
buffer[addr]=out[2]; ++addr;
buffer[addr]=out[3]; ++addr;


}}}


/****************************************************************************/
printf("\n\nWriting RGB table...\n\n");
	sprintf(fullname,"%s\\TABLE%d.RGB",path,eye);
	rgb=fopen(fullname,"wb");

	addr=0;
	for(g=0;g<256;++g){
	for(b=0;b<256;++b){
	for(r=0;r<256;++r){

		Rout=(char)buffer[addr]; ++addr;
		Gout=(char)buffer[addr]; ++addr;
		Bout=(char)buffer[addr]; ++addr;
	
		fwrite(&Bout,1,1,rgb); fwrite(&Gout,1,1,rgb); fwrite(&Rout,1,1,rgb);
	}}}
	fclose(rgb);
/****************************************************************************/
printf("Writing YUV table...\n\n");
	sprintf(fullname,"%s\\TABLE%d.YUV",path,eye);
	yuv=fopen(fullname,"wb");

	for(v=0;v<256;++v){
	for(u=0;u<256;++u){
	for(y=0;y<256;++y){

		out[1] = (float)(y + 1.402*(v-128));
		out[2] = (float)(y - 0.34414*(u-128) - 0.71414*(v-128));
		out[3] = (float)(y + 1.772*(u-128));
/*******************/
		for(i=1;i<=3;++i){
			if(out[i]<0)out[i]=0; if(out[i]>255)out[i]=255;						/* force [0-255] */
			num[i]=(int)floor(out[i]);											/* yuv => rgb (floor) */
			k[i] = out[i]-num[i];												/* get coeff for output interpolation */
		}
	
		addr=3*(num[2]*256*256 + num[3]*256 + num[1]);

		for(i=1;i<=3;++i)out2[i]=buffer[addr+i-1];								/* get floor table output = RGB (float)*/

/*******************/
		for(i=1;i<=3;++i)num[i]=(int)ceil(out[i]);								/* yuv => rgb (ceiling) */

		addr=3*(num[2]*256*256 + num[3]*256 + num[1]);

		for(i=1;i<=3;++i)out[i]=out2[i]+k[i]*(buffer[addr+i-1]-out2[i]);		/* Get ceiling and Interpolate */

/*******************/
		out2[1] = (float)(0.299*out[1] + 0.587*out[2] + 0.114*out[3] + 0.5);	/* RGB => YUV (float) */
		out2[2] = (float)((out[3]-out2[1])*0.565 + 128 + 0.5);
		out2[3] = (float)((out[1]-out2[1])*0.713 + 128 + 0.5);

		for(i=1;i<=3;++i){
			if(out2[i]<0)out2[i]=0; if(out2[i]>255)out2[i]=255;
			num[i]=(unsigned char)out2[i];
			fwrite(&num[i],1,1,yuv);
		}

	}}}

fclose (yuv);
}

fclose(dolby);
free (buffer);

/****************************************************************************/


}